//+------------------------------------------------------------------+
//|                                               MovingAv_EA.mq4    |
//+------------------------------------------------------------------+


extern string EAname   = "MovingAv_EA";
extern int    Risk     = 25;     //25%
int    SL              = 250;    //250
int    TP              = 70;     //70
int    TrailingStop    = 22;     //22
int    slippage        = 1;      //1
int    magic           = 2703;   //2703
double Lots            = 0.1;    //0.1  If not Money Management
bool   MM              = true;   //Use Money Management or not
bool   AccountIsMicro  = false;  //Use Micro-Account or not
         
datetime prevTime, curTime;
int ticket, cnt;

int init()
{
   prevTime = Time[0];
   magic = GenerateMagicNumber(magic, Symbol(), Period());
	EAname = GenerateComment(EAname, magic, Period());
	
	int maxOrders = OrdersTotal();
	int t_index;
	for (t_index=0; t_index<maxOrders; t_index++)
	{
		OrderSelect(t_index, SELECT_BY_POS, MODE_TRADES);
		if (magic==OrderMagicNumber())
		{			
			ticket   = OrderTicket();
			Lots     = OrderLots();
			break;
		}	
	}	
   return (0);
}

int deinit()
{
   return (0);
}

int start()
{
   curTime = Time[0];

   if (prevTime != curTime)
   {
      prevTime = curTime;
      
      double tmp =     iMA(NULL,0,9,0,MODE_EMA,PRICE_CLOSE,2);      
      double ma1 = tmp-iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,2); 
      double ma2 = tmp-iMA(NULL,0,10,0,MODE_EMA,PRICE_CLOSE,2); 
      double ma3 = tmp-iMA(NULL,0,15,0,MODE_EMA,PRICE_CLOSE,2); 
      double ma4 = tmp-iMA(NULL,0,20,0,MODE_EMA,PRICE_CLOSE,2);  
      double ma5 = tmp-iMA(NULL,0,25,0,MODE_EMA,PRICE_CLOSE,2);
      double ma6 = tmp-iMA(NULL,0,30,0,MODE_EMA,PRICE_CLOSE,2);
      double ma7 = tmp-iMA(NULL,0,32,0,MODE_EMA,PRICE_CLOSE,2);
     
      double prevTS = (ma1+ma2+ma3+ma4+ma5+ma6+ma7)/7;  
      
      tmp =     iMA(NULL,0,9,0,MODE_EMA,PRICE_CLOSE,1);     
      ma1 = tmp-iMA(NULL,0,7,0,MODE_EMA,PRICE_CLOSE,1); 
      ma2 = tmp-iMA(NULL,0,10,0,MODE_EMA,PRICE_CLOSE,1); 
      ma3 = tmp-iMA(NULL,0,15,0,MODE_EMA,PRICE_CLOSE,1); 
      ma4 = tmp-iMA(NULL,0,20,0,MODE_EMA,PRICE_CLOSE,1);  
      ma5 = tmp-iMA(NULL,0,25,0,MODE_EMA,PRICE_CLOSE,1);
      ma6 = tmp-iMA(NULL,0,30,0,MODE_EMA,PRICE_CLOSE,1);
      ma7 = tmp-iMA(NULL,0,32,0,MODE_EMA,PRICE_CLOSE,2);
      
      double curTS = (ma1+ma2+ma3+ma4+ma5+ma6+ma7)/7;
      double stoploss, takeprofit;
      
      if (prevTS <0 && curTS >0)
      {
         OrderClose(ticket, Lots, Ask, slippage, CLR_NONE);
         stoploss = 0;
         if (SL != 0) stoploss = Ask-SL*Point;
         takeprofit = 0;
         if (TP != 0) takeprofit = Ask+TP*Point;
         if(MM) Lots=subLotSize();
         ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, slippage, stoploss, takeprofit, EAname, magic, 0, CLR_NONE);         
      }
      else if (prevTS >0 && curTS <0)
      {
         OrderClose(ticket, Lots, Bid, slippage, CLR_NONE);
         stoploss = 0;
         if (SL != 0) stoploss = Bid+SL*Point;
         takeprofit = 0;
         if (TP != 0) takeprofit = Bid-TP*Point;
         if(MM) Lots=subLotSize();
         ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, slippage, stoploss, takeprofit, EAname, magic, 0, CLR_NONE);         
      }
   }
   
   if(TrailingStop>0)
   {
      for(cnt=0;cnt<OrdersTotal();cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderType()<=OP_SELL &&
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==magic)
         {
            if(OrderType()==OP_BUY)   // buy position is opened   
            {
               if(Bid-OrderOpenPrice()>Point*TrailingStop &&
                  OrderStopLoss()<Bid-Point*TrailingStop)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                  return(0);
               }
            }
            
            if(OrderType()==OP_SELL)   // sell position is opened   
            {
               if(OrderOpenPrice()-Ask>Point*TrailingStop)
               {
               if(OrderStopLoss()>Ask+Point*TrailingStop || OrderStopLoss()==0)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                  return(0);
               }
               }
            }
         }
      }
   }            
   
   return (0);
}

int GenerateMagicNumber(int seed, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD") isymbol = 1;
   else if (symbol == "GBPUSD") isymbol = 2;
   else if (symbol == "USDJPY") isymbol = 3;
   else if (symbol == "USDCHF") isymbol = 4;
   else if (symbol == "AUDUSD") isymbol = 5;
   else if (symbol == "USDCAD") isymbol = 6;
   else if (symbol == "EURGBP") isymbol = 7;
   else if (symbol == "EURJPY") isymbol = 8;
   else if (symbol == "EURCHF") isymbol = 9;
   else if (symbol == "EURAUD") isymbol = 10;
   else if (symbol == "EURCAD") isymbol = 11;
   else if (symbol == "GBPUSD") isymbol = 12;
   else if (symbol == "GBPJPY") isymbol = 13;
   else if (symbol == "GBPCHF") isymbol = 14;
   else if (symbol == "GBPAUD") isymbol = 15;
   else if (symbol == "GBPCAD") isymbol = 16;
   return (StrToInteger(StringConcatenate(seed, isymbol, timeFrame)));
}

string GenerateComment(string EAname, int magic, int timeFrame)
{
   return (StringConcatenate(EAname, "-", magic, "-", timeFrame));
}

//----------------------- MONEY MANAGEMENT FUNCTION  
//----------------------- SOURCE : CODERSGURU
double subLotSize()
{
     double lotMM = MathCeil(AccountBalance() *  Risk / 10000)/10;
	  
	  if(AccountIsMicro==false) //normal account
	  {
	     if(lotMM < 0.1)                  lotMM = Lots;
	     if(lotMM > 0.1)                  lotMM = lotMM;
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  else //micro account
	  {
	     if(lotMM < 0.01)                 lotMM = Lots;
	     if(lotMM > 0.01)                 lotMM = lotMM;
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  
	  return (lotMM);
}